Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.field.grid
Class ObjectGrid2D

    java.lang.Object
      sim.field.grid.AbstractGrid2D
          sim.field.grid.ObjectGrid2D

All Implemented Interfaces:
  java.io.Serializable, Grid2D

    public class ObjectGrid2D

extends AbstractGrid2D

A wrapper for 2D arrays of Objects.

This object expects that the 2D arrays are rectangular. You are encouraged to access the array directly. The object implements all of the Grid2D interface. See Grid2D for rules on how to properly implement toroidal or hexagonal grids.

The width and height of the object are provided to avoid having to say field[x].length, etc.

We very strongly encourage you to examine SparseGrid2D first to see if it's more appropriate to your task. If you need arbitrary numbers of Objects to be able to occupy the same location in the grid, or if you have very few Objects and a very large grid, or if your space is unbounded, you should probably use SparseGrid2D instead.

See Also:
  Serialized Form

Field Summary
`java.lang.Object[][]` | `field`

Fields inherited from class sim.field.grid.AbstractGrid2D
`height, width`

Fields inherited from interface sim.field.grid.Grid2D
`ALL, ANY, ANY_SIZE, BOUNDED, CENTER, TOROIDAL, UNBOUNDED`

Constructor Summary
`ObjectGrid2D(int width, int height)`
`ObjectGrid2D(int width, int height, java.lang.Object initialValue)`
`ObjectGrid2D(java.lang.Object[][] values)`
`ObjectGrid2D(ObjectGrid2D values)`

Method Summary
`Bag` | `clear()` Sets all the locations in the grid to null, and returns in a Bag all previously stored objects (including duplicates but not null values).
`Bag` | `elements()` Returns in a Bag all stored objects (including duplicates but not null values).
`java.lang.Object` | `get(int x, int y)` Returns the element at location (x,y)
`Bag` | `getHexagonalNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive.
`Bag` | `getHexagonalNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive.
`Bag` | `getMooreNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y).
`Bag` | `getMooreNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist.
`Bag` | `getNeighborsHamiltonianDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getNeighborsHexagonalDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getNeighborsMaxDistance(int x, int y, int dist, boolean toroidal, Bag result, IntBag xPos, IntBag yPos)` Deprecated.
`Bag` | `getRadialNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, int measurementRule, boolean closed, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getRadialNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, int measurementRule, boolean closed, Bag result, IntBag xPos, IntBag yPos)`
`Bag` | `getVonNeumannNeighbors(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist.
`Bag` | `getVonNeumannNeighborsAndLocations(int x, int y, int dist, int mode, boolean includeOrigin, Bag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist.
`void` | `set(int x, int y, java.lang.Object val)` Sets location (x,y) to val
`ObjectGrid2D` | `setTo(java.lang.Object thisObj)` Sets all the locations in the grid the provided element.
`ObjectGrid2D` | `setTo(java.lang.Object[][] field)` Sets the grid to a copy of the provided array, which must be rectangular.
`ObjectGrid2D` | `setTo(ObjectGrid2D values)` Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.
`java.lang.Object[]` | `toArray()` Flattens the grid to a one-dimensional array, storing the elements in row-major order,including duplicates and null values.

Methods inherited from class sim.field.grid.AbstractGrid2D
`buildMap, buildMap, dlx, dly, downx, downy, drx, dry, getHeight, getHexagonalLocations, getMooreLocations, getNeighborsHamiltonianDistance, getNeighborsHexagonalDistance, getNeighborsMaxDistance, getRadialLocations, getRadialLocations, getVonNeumannLocations, getWidth, removeOrigin, removeOriginToroidal, stx, sty, trb, trt, tx, ty, ulx, uly, upx, upy, urx, ury`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### field

    public java.lang.Object[][] field

Constructor Detail

### ObjectGrid2D

    public ObjectGrid2D(int width,
                        int height)

### ObjectGrid2D

    public ObjectGrid2D(int width,
                        int height,
                        java.lang.Object initialValue)

### ObjectGrid2D

    public ObjectGrid2D(ObjectGrid2D values)

### ObjectGrid2D

    public ObjectGrid2D(java.lang.Object[][] values)

Method Detail

### set

    public final void set(int x,
                          int y,
                          java.lang.Object val)

  Sets location (x,y) to val

### get

    public final java.lang.Object get(int x,
                                      int y)

  Returns the element at location (x,y)

### setTo

    public final ObjectGrid2D setTo(java.lang.Object thisObj)

  Sets all the locations in the grid the provided element. WARNING: this may conflict with setTo(Object[][]) -- make sure you have casted properly.

### setTo

    public ObjectGrid2D setTo(java.lang.Object[][] field)

  Sets the grid to a copy of the provided array, which must be rectangular. WARNING: this may conflict with setTo(Object) -- make sure you have casted properly.

### toArray

    public final java.lang.Object[] toArray()

  Flattens the grid to a one-dimensional array, storing the elements in row-major order,including duplicates and null values. Returns the grid.

### elements

    public final Bag elements()

  Returns in a Bag all stored objects (including duplicates but not null values). You are free to modify the Bag.

### clear

    public final Bag clear()

  Sets all the locations in the grid to null, and returns in a Bag all previously stored objects (including duplicates but not null values). You are free to modify the Bag.

### setTo

    public final ObjectGrid2D setTo(ObjectGrid2D values)

  Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.

### getNeighborsMaxDistance

    public Bag getNeighborsMaxDistance(int x,
                                       int y,
                                       int dist,
                                       boolean toroidal,
                                       Bag result,
                                       IntBag xPos,
                                       IntBag yPos)

  Deprecated.

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first.

  Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsMaxDistance(...) Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsMaxDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getMooreNeighbors

    public Bag getMooreNeighbors(int x,
                                 int y,
                                 int dist,
                                 int mode,
                                 boolean includeOrigin,
                                 Bag result,
                                 IntBag xPos,
                                 IntBag yPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist, This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first.

  Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsMaxDistance(...) Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getMooreNeighborsAndLocations

    public Bag getMooreNeighborsAndLocations(int x,
                                             int y,
                                             int dist,
                                             int mode,
                                             boolean includeOrigin,
                                             Bag result,
                                             IntBag xPos,
                                             IntBag yPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist. This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getNeighborsHamiltonianDistance

    public Bag getNeighborsHamiltonianDistance(int x,
                                               int y,
                                               int dist,
                                               boolean toroidal,
                                               Bag result,
                                               IntBag xPos,
                                               IntBag yPos)

  Deprecated.

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsHamiltonianDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getVonNeumannNeighbors

    public Bag getVonNeumannNeighbors(int x,
                                      int y,
                                      int dist,
                                      int mode,
                                      boolean includeOrigin,
                                      Bag result,
                                      IntBag xPos,
                                      IntBag yPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getVonNeumannNeighborsAndLocations

    public Bag getVonNeumannNeighborsAndLocations(int x,
                                                  int y,
                                                  int dist,
                                                  int mode,
                                                  boolean includeOrigin,
                                                  Bag result,
                                                  IntBag xPos,
                                                  IntBag yPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getNeighborsHexagonalDistance

    public Bag getNeighborsHexagonalDistance(int x,
                                             int y,
                                             int dist,
                                             boolean toroidal,
                                             Bag result,
                                             IntBag xPos,
                                             IntBag yPos)

  Deprecated.

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsHexagonalDistance(x,y,dist,toroidal ? Grid2D.TOROIDAL : Grid2D.BOUNDED, true, result, xPos, yPos);`

### getHexagonalNeighbors

    public Bag getHexagonalNeighbors(int x,
                                     int y,
                                     int dist,
                                     int mode,
                                     boolean includeOrigin,
                                     Bag result,
                                     IntBag xPos,
                                     IntBag yPos)

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  Places each x and y value of these locations in the provided IntBags xPos and yPos, clearing the bags first. Then places into the result Bag any Objects which fall on one of these locations, clearning it first. Note that the order and size of the result Bag may not correspond to the X and Y bags. If you want all three bags to correspond (x, y, object) then use getNeighborsAndCorrespondingPositionsHamiltonianDistance(...) Returns the result Bag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getHexagonalNeighborsAndLocations

    public Bag getHexagonalNeighborsAndLocations(int x,
                                                 int y,
                                                 int dist,
                                                 int mode,
                                                 boolean includeOrigin,
                                                 Bag result,
                                                 IntBag xPos,
                                                 IntBag yPos)

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself.

  For each Object which falls within this distance, adds the X position, Y position, and Object into the xPos, yPos, and result Bag, clearing them first. Some positions may not appear and that others may appear multiply if multiple objects share that positions. Compare this function with getNeighborsMaxDistance(...). Returns the result Bag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid2D.BOUNDED, Grid2D.UNBOUNDED, and Grid2D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid2D permits this but ObjectGrid2D and DoubleGrid2D and IntGrid2D and DenseGrid2D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y) point at the center of the neighborhood -- in the neighborhood results.

### getRadialNeighbors

    public Bag getRadialNeighbors(int x,
                                  int y,
                                  int dist,
                                  int mode,
                                  boolean includeOrigin,
                                  Bag result,
                                  IntBag xPos,
                                  IntBag yPos)

### getRadialNeighborsAndLocations

    public Bag getRadialNeighborsAndLocations(int x,
                                              int y,
                                              int dist,
                                              int mode,
                                              boolean includeOrigin,
                                              Bag result,
                                              IntBag xPos,
                                              IntBag yPos)

### getRadialNeighbors

    public Bag getRadialNeighbors(int x,
                                  int y,
                                  int dist,
                                  int mode,
                                  boolean includeOrigin,
                                  int measurementRule,
                                  boolean closed,
                                  Bag result,
                                  IntBag xPos,
                                  IntBag yPos)

### getRadialNeighborsAndLocations

    public Bag getRadialNeighborsAndLocations(int x,
                                              int y,
                                              int dist,
                                              int mode,
                                              boolean includeOrigin,
                                              int measurementRule,
                                              boolean closed,
                                              Bag result,
                                              IntBag xPos,
                                              IntBag yPos)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD